/*
 * DataDada - is an application that will turn the stored data on 
 * your hard drive into a movie complete with sound, image, and 
 * subtitles.  
 * 
 * Copyright (C) 2003 August Black
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * DataAudio.h
 */
#ifndef _DATAAUDIO_H_
#define _DATAAUDIO_H_

#include "Fifo.h"
extern "C" {
#include <portaudio.h>
#include "SDL_thread.h"
#include "SDL_mutex.h"
}

class DataAudio
{
 public:
  DataAudio();
  ~DataAudio();
  
  void Run(); // main thread in while(!quit) loop;
  void Error();
  void Quit();
  int FifoRead(void *buf, unsigned int &len);
  int FifoWrite( void *buf, unsigned int len );
  unsigned int FreeSpace();
  bool shouldQuit() { return quit; }

  int getSampleRate() { return sample_rate; }
  int getSamplesPerFrame() { return samples_per_frame; }
  int getFramesPerBlock() { return frames_per_block; }
  int getSampleSize() { return sample_size; }
  PortAudioStream *getStream() { return pa_stream; }

 private:
  int sample_rate;       // 44100
  int samples_per_frame; // 2
  int frames_per_block;  // 64
  int sample_size;       // sizeof(float)
  bool quit;
  PortAudioStream *pa_stream;
  PaError err;
  Fifo *fifo;
  SDL_mutex *mut;
  
};
#endif
