/*
 * DataDada - is an application that will turn the stored data on 
 * your hard drive into a movie complete with sound, image, and 
 * subtitles.  
 * 
 * Copyright (C) 2003 August Black
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Fifo.h
 */
#ifndef _FIFO_H_
#define _FIFO_H_

#include <memory.h>

class Fifo
{
 public:
  Fifo();
  Fifo(unsigned int size);
  ~Fifo();
  void Flush();
  int IsAlloc(void) { return astate; }
  int ReAlloc(unsigned int size);
  void * Read(void *buf, unsigned int &len);
  int Write(void *buf, unsigned int len);
  unsigned int FreeSpace(void);
  unsigned int UsedSpace(void);
 private:
  char *buffer;
  unsigned int astate;
  unsigned int totsize, start, datasize;
};
#endif
