/*
 * DataDada - is an application that will turn the stored data on 
 * your hard drive into a movie complete with sound, image, and 
 * subtitles.  
 * 
 * Copyright (C) 2003 August Black
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Flist.cpp
 */

#include <sys/stat.h> 
#include <dirent.h> 
#include <sys/types.h>
//#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef WIN
       #include <sys/types.h>
       #include <sys/stat.h>
       #include <unistd.h>
#define lstat stat
#include <io.h>
#include <direct.h>
#include <ctype.h>
#include <limits.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#endif

#include <iostream>
#include <string>
#include <string.h>
#include "Flist.h"

#ifdef WIN
  #define dir_separator  "\\"
#else
  #define dir_separator  "/"
#endif

void listDir(const char * sdir, int count,  Flist *fl);
int  flist_thread_func(void *tmp);

Flist::Flist() {
  count = 0;
  listmut = SDL_CreateMutex();
}

Flist::~Flist() {

}




void Flist::PrintList() {
  SDL_mutexP(listmut);
  for (vector<string>::iterator next = filelist.begin();
     next != filelist.end(); next++)
    {
      cout << (*next) << endl;
    }
  SDL_mutexV(listmut);
}
 
string Flist::getNextItem() {
  string tmp;
  count++;
  SDL_mutexP(listmut);

  if ( count == (int)filelist.size() ) {
    //SDL_Delay(300);
    //count--;
    SDL_mutexV(listmut);
    return "fuck end of list";
  }
  tmp = filelist[count];
  SDL_mutexV(listmut);
  return tmp;
}

string Flist::getFirstItem() {
  return (*filelist.begin());
}

string Flist::getLastItem() {

  vector<string>::iterator next;
  SDL_mutexP(listmut);
  next = filelist.end();
  next--;
  SDL_mutexV(listmut);
  return (*next);
}
 
void Flist::Run( string thedir ) {
  dir = thedir;  
  list_thread = SDL_CreateThread( flist_thread_func, (void *)this );
}

int flist_thread_func(void *tmp){ 
  Flist *fl = (Flist *)tmp;
  listDir( fl->getDir().c_str(), 0, fl);  
  return 0;
}

void listDir(const char * sdir, int count, Flist *fl){ 

  string strDir;
  struct dirent *dptr;
  struct  stat  st;
  vector < string > *m_vectData = &fl->filelist;

  DIR *dirp;

  if( (dirp = opendir(sdir)) == NULL ) { 
    //perror(str.c_str() );
    return; 
  } 

  if (lstat (sdir, &st) == -1) {
#ifdef DEBUG
    cerr << " couldn't stat this directory " << sdir << endl;
#endif
  }
#ifndef WIN
  if ( S_ISLNK(st.st_mode) ) {
    closedir(dirp);
    return;
  }
#endif
  if ( S_ISBLK(st.st_mode) ) {
    closedir(dirp);
    return;
  }
  if ( S_ISFIFO(st.st_mode) ) {
    closedir(dirp);
    return;
  }

  while( ( dptr =  readdir(dirp) ) ) { 
    
    if ( ( strcmp( dptr->d_name, "." ) == 0 ||  strcmp( dptr->d_name, ".." ) == 0 || strcmp( dptr->d_name, "dev" ) == 0)) {
    //if ( ( (string)dptr->d_name == (string)"."  ||  (string)dptr->d_name == (string)".." ) ) {
      continue;
    }

    strDir = sdir + (string)dir_separator + (string) dptr->d_name;

    if (lstat (strDir.c_str(), &st) == -1) {
#ifdef DEBUG
      cerr << "     couldn't stat the file" << endl;
#endif
      continue;
    }

#ifdef WIN
    if (  S_ISDIR(st.st_mode)  && !S_ISFIFO(st.st_mode) && !S_ISBLK(st.st_mode) ) { 
#else
    if (  S_ISDIR(st.st_mode) && !S_ISLNK(st.st_mode) && !S_ISFIFO(st.st_mode) && !S_ISBLK(st.st_mode) ) { 
#endif
      //here is the recursion
      //if ( S_ISLNK(st.st_mode) ) {
      //cerr << "dir link " << strDir << endl;
      //continue; }
      listDir(strDir.c_str(), count++, fl);
      continue;
    } else {
#ifdef WIN
      if ( S_ISREG(st.st_mode) && !S_ISFIFO(st.st_mode) && !S_ISBLK(st.st_mode)) { 
#else      
      if ( S_ISREG(st.st_mode) && !S_ISLNK(st.st_mode) && !S_ISFIFO(st.st_mode) && !S_ISBLK(st.st_mode)) { 
#endif
	//if it is a regular file
	SDL_mutexP( fl->getListMut() );
	m_vectData->push_back(strDir); 
	SDL_mutexV(fl->getListMut() );
      } else {
#ifdef DEBUG
	cerr << "not a regular file " << strDir << endl;
#endif
      }
    }
  }
  closedir(dirp);  // VERY important!!
}

