/*
 * DataDada - is an application that will turn the stored data on 
 * your hard drive into a movie complete with sound, image, and 
 * subtitles.  
 * 
 * Copyright (C) 2003 August Black
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Flist.h
 */

#ifndef _FLIST_H_
#define _FLIST_H_

#include <string>
#include <vector>

extern "C" {
#include <SDL.h>
#include <SDL_thread.h>
#include "SDL_mutex.h"
}

using namespace std;


class Flist
{
 public:
  Flist();
  ~Flist();
  void Run( string dir );
  void PrintList();
  //id ListDir(const char * sdir);
  string getNextItem();
  string getFirstItem();
  string getLastItem();
  string getDir() { return dir; }
  //vector < string > getFilelist() { return filelist; } 
  vector < string > filelist; 
  SDL_mutex *getListMut() { return listmut; }
  
 private:

  long count;
  string dir;
  SDL_Thread *list_thread;
  SDL_mutex *listmut;
};
#endif
