#include <sys/stat.h> 
//#include <sys/types.h> 
#include <dirent.h> 
//#include <unistd.h>
//#include <fcntl.h>

#include <errno.h>
//#include <stdio.h>

//#include <SDL/SDL.h>

#include <string>
#include <iostream>
#include <vector>

using namespace std;


void listDir(const char * sdir, vector < string > *m_vectData);


int main(int argc, char *argv[]){
  vector < string > filelist; 

  listDir(".", &filelist); 

  for (vector<string>::iterator next = filelist.begin();
       next != filelist.end(); next++)
    {
      cout << (*next) << endl;
    }


  //for (int i=0; i< filelist.size(); i++){ 
  //printf("%s\n", m_vectData[i].c_str()); 
  //cout << filelist[i] << endl;
  //} 

  return 0; 
}




void listDir(const char * sdir, vector < string > *m_vectData){ 
  string str, strDir;
  struct dirent *dptr;
  struct stat st;
  DIR *dirp;

  if( (dirp = opendir(sdir)) == NULL ) { 

    cerr << "Error opening %s:" << endl; 
    switch(errno){ 
    case EACCES : { 
      cerr << "Search permission is denied for a component of the path name prefix of dirname";
      cerr << "or read permission is denied for the directory." << endl; 
      break; 
    }
    case ENAMETOOLONG : {
      cerr  << "\tThe length of the dirname parameter exceeds PATH_MAX ";
      cerr << "or a path name component is longer than NAME_MAX." << endl; 
      break; 
    } 
    case ENOENT : { 
      cerr  << "\tThe named directory does not exist or dirname points to an empty ";
      cerr << "string or a component of dirname is not a directory." << endl; 
      break; 
    } 
    case ENOTDIR : { 
      cerr << "\tThe argument dirname does not refer to a directory." << endl; 
      break; 
    } 
    case ENOMEM : { 
      cerr << "\tNot enough memory to create the directory stream." << endl; 
      break; 
    } 
    default : { 
      cerr  << "\tUnknown value for errno: " << errno << endl;
    } 
    } 
    return; 
  } 

  while( ( dptr =  readdir(dirp) ) ) { 
    //skip if find . and ...
    if ( ( strcmp(dptr->d_name, ".") == 0 ||  strcmp(dptr->d_name, "..") == 0)) {
      continue;
    }
    str = "";
    //for (int i=0; i<count; i++) { str += " "; } //indentation for better viewing 

    strDir = sdir + (string) "/" + (string) dptr->d_name;

    //if (stat (strDir.c_str(), &st) == -1) {
    //  cout << "     couldn't stat the file" << endl;
    //}

    if ( stat (strDir.c_str(), &st) == -1 && S_ISDIR (st.st_mode) ) { //join given path and file name 
      //str += "D: " + strDir;
      //cout << "Dir: " << strDir << endl;
      //cout << "directory" << strDir << endl;
      //here is the recursion
      listDir(strDir.c_str(), m_vectData );
      continue;
    } else {
      //str += "F: " + (string) sdir + (string) "/" + (string) dptr->d_name;
      //cout << strDir << endl;
      m_vectData->push_back(strDir); 
      //do_file( strDir.c_str() );
    }
  }
}
