#include <stdio.h>
#include <stdlib.h>
#include <math.h>   // for sin function to fill audio table, only for testing

#include <sys/types.h>  //open, lseek, etc.
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "DataVideo.h"
#include "Flist.h"

#define SCALE (1./(1024. * 1024. * 1024. * 2.))

int main(int argc, char *argv[]){

  DataVideo *datavid = new DataVideo();
  Flist *fl = new Flist();
  string filename;
  int fd;
  int ret;
  int len = 128;
  short buf[len];
  int count;

  if (argc > 1) {
    fl->Run(argv[1]);
  } else {
    fl->Run(".");
  }
  
  SDL_Delay(1000); //wait half a  second or so to let Flist get a listing
  
  //fl->PrintList();
  fd = -1;
  while ( fd == -1) {
    filename = fl->getNextItem();
    //return and exit if we are at end of list
    if ( filename == fl->getLastItem()) { cout<< "last item reached" << endl; return 1; }  
    fd = open( filename.c_str(),  O_RDONLY ); 
    if (fd == -1) {
      fprintf(stderr, "couldnt open file %s, trying again\n", filename.c_str());
      close(fd);
    }
  }	
  fprintf(stderr, "first file is %s\n", filename.c_str());

  datavid->Init(500,300,32);
  fprintf(stderr, "first file is %s\n", filename.c_str());

  datavid->Run();
  
  fprintf( stderr, "After running audio\n" );
  
  count = 0;
  
  while ( !datavid->shouldQuit() ) {

    // fill audio and vido fifos and wait for conditional
    while ( datavid->FreeSpace( ) >= (unsigned int)(len*4) ) {
      ret = read(fd, buf, len );
      if (ret < len) {  // reached end of file
	close(fd); fd = -1;
	while ( fd == -1) {
	  filename = fl->getNextItem();
	  //if ( filename == fl->getLastItem()) return 1;  //return and exit if we are at end of list
	  fd = open( filename.c_str(),  O_RDONLY ); 
	  if (fd == -1) 	
	    printf("       couldn't open %s\n", filename.c_str());
	}	
	printf("%s\n", filename.c_str());
      }
      datavid->FifoWrite( (void *)buf, ret);
      datavid->setFilename(filename.c_str() );
    }


    
    //SDL_CondWait(audiocond, mut);
    SDL_Delay(10);
  }
  
  printf("quitting in main, why?");
  datavid->Quit();
  SDL_Quit();
}

